import { CameraState, MouseCoords, TouchCoords } from "sigma/types";
export interface MouseEvent {
    event: MouseCoords;
}
export interface TouchEvent {
    event: TouchCoords;
}
export interface NodeEvent {
    node: string;
}
export declare type MouseNodeEVent = MouseEvent & NodeEvent;
export interface EventHandlers {
    clickNode: ({ node, event }: MouseNodeEVent) => void;
    rightClickNode: ({ node, event }: MouseNodeEVent) => void;
    downNode: ({ node, event }: MouseNodeEVent) => void;
    enterNode: ({ node }: NodeEvent) => void;
    leaveNode: ({ node }: NodeEvent) => void;
    clickStage: ({ event }: MouseEvent) => void;
    rightClickStage: ({ event }: MouseEvent) => void;
    downStage: ({ event }: MouseEvent) => void;
    click: ({ event }: MouseEvent) => void;
    rightClick: ({ event }: MouseEvent) => void;
    mouseup: ({ event }: MouseEvent) => void;
    mousedown: ({ event }: MouseEvent) => void;
    mousemove: ({ event }: MouseEvent) => void;
    touchup: ({ event }: TouchEvent) => void;
    touchdown: ({ event }: TouchEvent) => void;
    touchmove: ({ event }: TouchEvent) => void;
    kill: () => void;
    cameraUpdated: (e: CameraState) => void;
}
